//+------------------------------------------------------------------+
//|                                                         Zmey.mq4 |
//|                                           Copyright 2015, NickAC |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright 2015, NickAC"
#property link      "karabas_72@mail.ru"
#property version   "1.00"
#property strict

#property indicator_chart_window
#property indicator_buffers 5

extern double Lots            = 50.0; // 
extern double Multiplier      = 2.0;  //  
extern double Mexp            = 5.0;  //  
extern int    magic           = 963741;
extern int    slippage        = 3;    // 
extern int    HourStart       = 09;   //  
extern int    HourEnd         = 15;   //  

extern string RVI             = " RVI";
extern int    ExtRVIPeriod=4;         // RVI Period
#property     indicator_color1  Green
#property     indicator_color2  Red

extern string TMATrue             = " TMA";
extern int eintTimeframe = 0;
extern int eintHalfLength = 56;
extern double edblAtrMultiplier = 3.0;
extern int eintAtrPeriod = 100;
extern int eintBarsToProcess = 0;
extern bool eblnAlerts = false;
//---- indicator buffers
double gadblMid[];
double gadblUpper[];
double gadblLower[];

extern string MACD            = " MACD";
extern int    InpFastEMA      = 6;     // Fast EMA Period
extern int    InpSlowEMA      = 20;    // Slow EMA Period
extern int    InpSignalSMA    = 4;     // Signal SMA Period

double PriceHigh,PriceLow,MacdCurrent,SignalCurrent,PRICE_OPEN,PRICE_CLOSE;
int    ticket,Comment,TimeFrame;
 
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()

  {
   if (Digits==3||Digits==5)
   {
    slippage*=10;
   }
   {
    Comment=TimeFrame*Mexp;
   }
   return(INIT_SUCCEEDED);
  }
  
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[]
               )
  {
   return(rates_total);  
  }
  
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
int OnDeinit(const int reason)
  {
   return(0);
  }
                
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
    if (CountTrades()==0)
   {
    PriceHigh=iCustom(Symbol(),0,TMATrue,eintTimeframe,eintHalfLength,edblAtrMultiplier,eintAtrPeriod,eintBarsToProcess,eblnAlerts,1,0);
    PriceLow =iCustom(Symbol(),0,TMATrue,eintTimeframe,eintHalfLength,edblAtrMultiplier,eintAtrPeriod,eintBarsToProcess,eblnAlerts,2,0);
    MacdCurrent=iMACD(NULL,0,InpFastEMA,InpSlowEMA,InpSignalSMA,PRICE_CLOSE,MODE_MAIN,0);
    SignalCurrent=iMACD(NULL,0,InpFastEMA,InpSlowEMA,InpSignalSMA,PRICE_CLOSE,MODE_SIGNAL,0);
    
    if (PRICE_OPEN<PriceLow&&PRICE_OPEN<PRICE_CLOSE&&SignalCurrent<MacdCurrent&&indicator_color2<indicator_color1)
     {
      ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,slippage,0,0,Comment,magic,0,Blue);
     }
   }
   else if (PRICE_OPEN>PriceHigh&&PRICE_OPEN>PRICE_CLOSE&&SignalCurrent>MacdCurrent&&indicator_color2>indicator_color1)
     {
      ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,slippage,0,0,Comment,magic,0,Red);
     }
   
  }
  
//+------------------------------------------------------------------+
  int CountTrades ()
  {
    int count=0;
    for (int i=OrdersTotal()-1;i>=0;i--)
    {
     if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
     {
      if(OrderSymbol()==Symbol()&&OrderMagicNumber()==magic)
        count++;
     }
    }
    return(count);
  }